provides :livelink_zabbix_agent

property :name, String, name_property: true
property :version, String, default: node['zabbix']['version']
property :pid_file, String, default: '/var/run/zabbix/zabbix_agentd.pid'
property :log_file, String, default: '/var/log/zabbix/zabbix_agentd.log'
property :log_file_size, Integer, default: 1024
property :debug_level, [0, 1, 2, 3, 4, 5], default: 3
property :enable_remote_commands, [0, 1], default: 0
property :log_remote_commands, [0, 1], default: 1
property :server, String, default: 'DYNAMIC'
property :listen_port, Integer, default: 10_050
property :listen_ip, String, default: '0.0.0.0'
property :start_agents, Integer, default: 3
property :server_active, String, default: 'DYNAMIC'
property :hostname, String, default: node['fqdn']
property :host_metadata, String, default: 'debian'
property :refresh_active_checks, Integer, default: 120
property :buffer_send, Integer, default: 5
property :buffer_size, Integer, default: 100
property :max_lines_per_second, Integer, default: 100
property :timeout, Integer, default: 3
property :allow_root, [0, 1], default: 0
property :user, String, default: 'zabbix'
property :include, [Array, String],
         default: '/etc/zabbix/zabbix_agent.conf.d/*.conf'
property :unsafe_user_parameters, [0, 1], default: 1
property :server_select_environment, String, default: node.chef_environment
property :server_port, Integer, default: 10_051

action :create do
  raise 'Multiple Zabbix Agent Recipes included!' if node.recipe?('zabbix::agent')
  node.default['zabbix']['is_agent'] = true
  node.save
  livelink_zabbix_repo new_resource.version

  package 'zabbix-agent'

  directory '/etc/zabbix' do
    owner 'zabbix'
    group 'zabbix'
  end

  directory '/etc/zabbix/zabbix_agent.conf.d' do
    owner 'zabbix'
    group 'zabbix'
  end

  proxy_node = my_proxy
  update_for_proxy(new_resource)
  template '/etc/zabbix/zabbix_agentd.conf' do
    source 'agent/zabbix_agentd.conf.erb'
    cookbook 'livelink-zabbix'
    owner 'zabbix'
    group 'zabbix'
    mode '0600'
    variables resource: new_resource
    notifies :restart, 'service[zabbix-agent]', :delayed
  end

  service 'zabbix-agent' do
    action [:start, :enable]
  end
end
